
#property indicator_chart_window
extern string TimeFrame_Text   = "Enter help in TimeFrame for information";
extern string TimeFrame        = "M15,H4";
extern int    Window           = 0;
extern int    Corner           = 2;
extern int    X_position       = 2;
extern int    Y_position       = -4;
  //extern color BackGroundColor  = White;
extern bool   SortedDisplay     = true;

color    PanelColor1     = Silver;
color    PanelColor2     = Black;
                      
string   TimeFrames[];
string   sTimeFrames[]={"0","M1","M5","M15","M30","H1","H4","D1","W1","MN1",  //  0- 9
                        ",help","Help","chart","Chart",                       // 10-13
                        "+0","+1","+2","+3","+4","+5","+6","+7","+8",         // 14-22
                        "-0","-1","-2","-3","-4","-5","-6","-7","-8"};        // 23-31
int      iTimeFrames[]={0,PERIOD_M1,PERIOD_M5,PERIOD_M15,PERIOD_M30,PERIOD_H1,PERIOD_H4,PERIOD_D1,PERIOD_W1,PERIOD_MN1};
int      TimePeriods=10, timeframe, timeframes[],timeindex[],time_index,Number_timeframes;

string buffer_name = "CP 5: ";
int Font_size = 12;

#define Majors_Number 8

int chartpair[2];
string buffer;
string Majors[]  = {"USD","EUR","GBP","JPY","CHF","CAD","NZD","AUD"};            
string Symbols[] = {"EURUSD","GBPUSD","USDJPY","USDCHF","USDCAD","AUDUSD","NZDUSD",
                    "EURGBP","EURJPY","EURCHF","EURCAD","EURAUD","EURNZD",
                    "GBPJPY","GBPCHF","GBPCAD","GBPAUD","GBPNZD",
                    "AUDJPY","AUDCHF","AUDCAD","AUDNZD",
                    "CHFJPY","CADJPY","NZDJPY",
                    "USDSGD"};
string space = "";
string NomeIndi;
int Xoffset=132; 
 
int Translate(string symbol)
   {
   for(int i=0;i<Majors_Number;i++)     if(Majors[i] == symbol)   break; 
   return(i);
   }
   
int Count_Tokens(string Input)
{
   int cnt,pos=0;
   while(pos>-1)
      {
      pos=StringFind(Input,",",pos+1);
      if(pos>-1)      cnt+=1;  
      }
      cnt+=1;
   return(cnt);
}
int Parse_Tokens(string Input, string& Output[])
{
   int Tokens=Count_Tokens(Input); 
   ArrayResize(Output,Tokens);
   
   int i,start=0,stop=-1;
   for(i=0;i<Tokens-1;i++)
      {
      stop=StringFind(Input,",",stop+1);
      Output[i]=StringSubstr(Input,start,stop-start);
      start=stop+1;
      }
   Output[i]=StringSubstr(Input,start);
   return(Tokens);  
}   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   Number_timeframes=Parse_Tokens(TimeFrame,TimeFrames);
   ArrayResize(timeindex,Number_timeframes); 
   ArrayResize(timeframes,Number_timeframes);
   
   for(time_index=0;time_index<Number_timeframes;time_index++)
      {
      TimeFrame=TimeFrames[time_index];
  
      int TimeIndex=Verify_TimeFrame(TimeFrame);
      if(TimeIndex==-1)  Help();
      if(TimeIndex < TimePeriods)
         {
         timeindex[time_index]=TimeIndex;
         timeframes[time_index]=iTimeFrames[TimeIndex];
         }
      }
   
   NomeIndi = WindowExpertName();
   string currency=StringSubstr(Symbol(),0,3);
   chartpair[0]=Translate(currency);
   currency=StringSubstr(Symbol(),3,3);
   chartpair[1]=Translate(currency);
   Show_Panel();
   Y_position+=2; 
  
  return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
  for (int i = 0; i <= ArraySize(Majors)*2; i++) 
      {    
       ObjectDelete(Majors[i]+"_val"+timeframe);
       ObjectDelete(Majors[i]+"_nom"+timeframe);
       ObjectDelete(Majors[i]+"_pos"+timeframe);
       }    
  buffer= buffer_name+"AA-Panel-";
  for(i=1;i<6;i++)
      {
         
       ObjectDelete(buffer+"1");
      } 
      DeleteExistingLabels();
  
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

void  Show_Panel()
{
   
      string text="ggg";
      int xoffset=130,fontsize=84,time_offset;
      switch(Number_timeframes)
         {
         case 1: fontsize=80; text="ggg";  break;
         case 2: fontsize=65; text="ggg";  break;
         case 3: fontsize=80; text="ggg";  break;
         case 4: fontsize=85; text="ggg";  break;
         }
      buffer=buffer_name+"AA-Panel-";

      CreateXX2_Labels( buffer + "1"+timeframe,X_position+Xoffset-xoffset+1,Y_position+74, text, fontsize-1, "Webdings", PanelColor1);
      CreateXX2_Labels( buffer + "2"+timeframe,X_position+Xoffset-xoffset+1,Y_position+12, text, fontsize-1, "Webdings", PanelColor1); 
      CreateXX2_Labels( buffer + "3"+timeframe,X_position+Xoffset-xoffset+3,Y_position+73, text, fontsize-2, "Webdings", PanelColor2); 
      CreateXX2_Labels( buffer + "4"+timeframe,X_position+Xoffset-xoffset+3,Y_position+14, text, fontsize-2, "Webdings", PanelColor2); 
      CreateXX2_Labels( buffer + "5"+timeframe,X_position+Xoffset-xoffset+33,Y_position+138,"Currency Power ", 12, "Courier New Bold", PanelColor1);
      for(time_index=0;time_index<Number_timeframes;time_index++)
         {
         time_offset=time_index*40;
         CreateXX2_Labels( buffer + "6"+timeframe+time_index,X_position+Xoffset-xoffset+181+time_offset,Y_position+139, sTimeFrames[timeindex[time_index]], 10, "Courier New Bold", PanelColor1);  
         }      
}
int start()
  {
   int    counted_bars=IndicatorCounted();
   int xoffset=130;

   displayMeter();
 
   return(0);
  }
  
//+------------------------------------------------------------------+
//| displayMeter function                                            |
//+------------------------------------------------------------------+
void displayMeter() 
   {
   double ValoreZero[Majors_Number,5],value;
   int win = WindowFind(NomeIndi);
   int j,Y2=Y_position+14,nom_offset,val_offset,time_offset;
   string Font,Name;
      
     
      for(int currency=0; currency<Majors_Number; currency++)
         {
         for(time_index=0;time_index<Number_timeframes;time_index++) 
                  ValoreZero[currency,time_index] = currency_strength(Majors[currency], timeframes[time_index]);
               
         ValoreZero[currency,4] = currency;
         }

   if(SortedDisplay)
      {
      int mode=MODE_DESCEND;
      if(Corner > 1)   mode=MODE_ASCEND;
      ArraySort(ValoreZero,WHOLE_ARRAY,0,mode);
      }
  
      for(int i=0; i<Majors_Number; i++)
         {
         j = ValoreZero[i,4];
         color Color=SpringGreen;
         Font="Courier New";
         buffer=buffer_name + Majors[j];
         switch(Corner)
            {
            case 0: Name=(i+1)+" "+Majors[j]; nom_offset=-124;  val_offset=47;   break;
            case 1: Name=(i+1)+" "+Majors[j]; nom_offset=26;    val_offset=-124; break;
            case 2: Name=(8-i)+" "+Majors[j]; nom_offset=-124;  val_offset=47;   break;
            case 3: Name=(8-i)+" "+Majors[j]; nom_offset=26;    val_offset=-124; break;
            }
         if(j == chartpair[0] || j == chartpair[1]) {Font="Courier New Bold"; Color=White;}
         objectCreate(buffer+"_nom"+timeframe, Corner, X_position+Xoffset+nom_offset, Y2, 0, Name, Font_size, Font, Color);
         
      for(time_index=0;time_index<Number_timeframes;time_index++)
         { 
         value=ValoreZero[i,time_index]*10.0;   
         time_offset=time_index*40;
         objectCreate(buffer+time_index+"_val"+timeframe, Corner, X_position+Xoffset+val_offset+time_offset, Y2, 0, DoubleToStr(value,0)+"%", Font_size, Font, Color);
         }
         
         value=ValoreZero[i,0]*10.0;
         paintCurr(i,value,X_position+Xoffset-150,Y2+6);
         Y2 += 15;
      }  
}
void paintCurr(int key,double value,int Xpos,int Ypos) 
{ 
   initGraph(key,Xpos,Ypos);
   if (value >  0.0) ObjectSet(buffer + "10", OBJPROP_COLOR, C'55,90,80');
   if (value > 10.0) ObjectSet(buffer + "9",  OBJPROP_COLOR, C'65,100,100');
   if (value > 20.0) ObjectSet(buffer + "8",  OBJPROP_COLOR, C'80,120,120');
   if (value > 30.0) ObjectSet(buffer + "7",  OBJPROP_COLOR, C'95,140,140');
   if (value > 40.0) ObjectSet(buffer + "6",  OBJPROP_COLOR, C'110,160,160');
   if (value > 50.0) ObjectSet(buffer + "5",  OBJPROP_COLOR, C'125,180,180');
   if (value > 60.0) ObjectSet(buffer + "4",  OBJPROP_COLOR, C'140,200,200');
   if (value > 70.0) ObjectSet(buffer + "3",  OBJPROP_COLOR, C'155,220,220');
   if (value > 80.0) ObjectSet(buffer + "2",  OBJPROP_COLOR, C'170,240,240');
   if (value > 90.0) ObjectSet(buffer + "1",  OBJPROP_COLOR, C'185,255,255');
  
}
void initGraph(int key, int Xpos, int Ypos) {
   int i,ri, k=50;
   buffer=buffer_name + "Bar "+timeframe+key+ "_";
   for(i=1;i<11;i++)
      {
      k=k+11;
      ri=i;
      if(Corner==0 || Corner==2)    ri=11-i;  
      ObjectDelete(buffer+ri);   
      objectCreatea(buffer + ri ,Xpos+k,Ypos);
      }
}
//+------------------------------------------------------------------+
//| currency_strength function                                       |
//+------------------------------------------------------------------+
double currency_strength(string couple, int argtimeframe) {
   int index, cnt=0;
   string Pair;
   double HiLo;
   double ld_28;
   double ld_ret_36 = 0;
   
   for (int i = 0; i < ArraySize(Symbols); i++) {
      index = 0;
      Pair = Symbols[i];
      if (couple == StringSubstr(Pair, 0, 3) || couple == StringSubstr(Pair, 3, 3)) {
         Pair = Pair + space;
         
        double CURR  = (MarketInfo(Pair, MODE_BID));
        
        double OPN   = iOpen(Pair,argtimeframe,0);
        double LO    = iLow(Pair,argtimeframe,0);
        double CL    = iClose(Pair,argtimeframe,0);
        double HI    = iHigh(Pair,argtimeframe,0);
         
       double percent_up1=((CL-OPN));
       double percent_dn1=((OPN-CL));
           
       double change; 
       if(CURR>0){change = percent_up1;}
       if(CURR<0){change = percent_dn1;}
           
         
            HiLo = (iHigh(Pair,argtimeframe,0) - iLow(Pair,argtimeframe,0)) * MarketInfo(Pair, MODE_POINT);
            if (HiLo != 0.0) {
            ld_28 = 100.0 * ((change) / HiLo * MarketInfo(Pair, MODE_POINT));
            if (ld_28 >  3.0) index = 1;
            if (ld_28 > 10.0) index = 2;
            if (ld_28 > 25.0) index = 3;
            if (ld_28 > 40.0) index = 4;
            if (ld_28 > 50.0) index = 5;
            if (ld_28 > 60.0) index = 6;
            if (ld_28 > 75.0) index = 7;
            if (ld_28 > 90.0) index = 8;
            if (ld_28 > 97.0) index = 9;
            cnt++;
            if (couple == StringSubstr(Pair, 3, 3)) index = 9 - index;
            ld_ret_36 += index;
         }
      }
   }
   ld_ret_36 /= cnt;
   return (ld_ret_36);
}

//+------------------------------------------------------------------+
//| objectCreate function                                            |
//+------------------------------------------------------------------+
void objectCreate(string nome, int angolo, int val_x, int val_y, int val_ang, string testo = "-", int fontsize = 42, string fontname = "Arial", color color1 = -1)
   {
   if (ObjectFind(nome) != 0)       ObjectCreate(nome, OBJ_LABEL, Window, 0, 0);
   
   ObjectSet(nome, OBJPROP_CORNER, Corner);
   ObjectSet(nome, OBJPROP_COLOR, color1);
   ObjectSet(nome, OBJPROP_BACK, 0);
   ObjectSet(nome, OBJPROP_XDISTANCE, val_x+X_position);
   ObjectSet(nome, OBJPROP_YDISTANCE, val_y);
   ObjectSet(nome, OBJPROP_ANGLE, val_ang);
   ObjectSetText(nome, testo, fontsize, fontname, color1);
   }
   
void CreateXX2_Labels( string bj, int xj, int yj, string text, int fontsize, string font, color colore ) 
   {
   ObjectCreate( bj, OBJ_LABEL, Window, 0, 0 );
   ObjectSet( bj, OBJPROP_CORNER, Corner );
   ObjectSet( bj, OBJPROP_XDISTANCE,xj+X_position-1);
   ObjectSet( bj, OBJPROP_YDISTANCE,yj+(Font_size/fontsize)-1);
   ObjectSet( bj, OBJPROP_BACK, 0 );
   ObjectSetText(bj, text, fontsize, font, colore);
   }

void objectCreatea(string a_name_0, int Xpos, int Ypos, string a_text_16 = "g", int a_fontsize_24 = 8, string a_fontname_28 = "Webdings", color Color = C'15,50,25' ) {
   ObjectCreate(a_name_0, OBJ_LABEL, Window, 0, 0);
   ObjectSet(a_name_0, OBJPROP_CORNER, Corner);
   int xoffset=0;  if(Corner==0 || Corner==2)   xoffset=21;
   ObjectSet(a_name_0, OBJPROP_XDISTANCE, Xpos + xoffset + X_position);
   ObjectSet(a_name_0, OBJPROP_YDISTANCE, Ypos -4);
   ObjectSetText(a_name_0, a_text_16, a_fontsize_24, a_fontname_28, Color);
}

void DeleteExistingLabels() {
   string l_name_4;
   int l_objs_total_0 = ObjectsTotal(OBJ_LABEL);
   if (l_objs_total_0 > 0) {
      for (int l_objs_total_12 = l_objs_total_0; l_objs_total_12 >= 0; l_objs_total_12--) {
         l_name_4 = ObjectName(l_objs_total_12);
         if (StringFind(l_name_4, buffer_name, 0) >= 0) ObjectDelete(l_name_4);
      }
   }
}

void  Help()
{  return;
   Alert("If the default timeframe for the chart is H1, then +1 will indicate H4, -1 indicates M30");
   Alert("Enter +1 to specify the next higher TimeFrame; -1 to specify the next lower TimeFrame");
   Alert("To specify variable TimeFrames, use either + or - followed by a number 1 to 8");
   Alert("Variable TimeFrames use the default time period for the chart and add or subtract an offset");
   Alert("By using Variable TimeFrames, you may change the default timeframe on the chart and the indicators will change accordingly");
   Alert("Variable TimeFrames are provided so you can specify multiple Currency Power indicators on the same chart");
   Alert("To specify the default time period for the chart, use chart");
   Alert("Constant TimeFrames are specified using the Metatrader mneumonics, M1,M15,M30.. through MN1");
   Alert("***Help for TimeFrame Input***");
}  
int Verify_TimeFrame(string Timeframe)
{
   int limit=ArraySize(sTimeFrames);
   for(int i=0;i<limit;i++) if(Timeframe == sTimeFrames[i])  break;
   if(i < TimePeriods   ) return(i);
   if(i == 10 || i == 11) return(-1);
   if(i == 12 || i == 14) return(Find_TimeIndex(Period()));
   if(i > 13 && i < limit)
      {
      int t=Find_TimeIndex(Period());
      if(i < 22 )  i=t+i-14;
      else         i=t+23-i;
      return(i);
      }   
   
   Help();
   Alert("***Invalid TimeFrame = " + Timeframe);
   return(-1);
}  
         
int Find_TimeIndex(int time)
{
   for(int i=0;i<TimePeriods;i++) if(iTimeFrames[i] == time)    return(i);
   Help();
   Alert("***Invalid Time Period = "+time);
   return(-1);  
}         


